%In this example we explain how to get an design-centering problem. This 
%is very similar to the usage described in exUsageOfNativeProblems. We will
%also plot the DC-Problems. Ther are more ways to create an DCProblem. Some
%examples are given in exCreateDCProblems.

%The first possibility to get an design-centering problem is to take a
%problem found in the literature. For example DCProblem3 (Ellipsoid into a
%concavified triangle). For the creation of further examples, take a look
%at exCreateDCProblems or exCreateMultipleBodyDCProblems

p=DCProblem3

%We now have a GSIP. So we can evaluate some of it's functions

disp('evaluate objective function')

fval=p.evalObjFun([2.1107,-1.0000,0.5615,2.3032,-0.4385])

disp('evaluate a semi-infinite constraint')
g=p.evalSemiInfConstrs(1,[2.1107,-1.000,0.5615,2.3032,-0.4385],[2,0])

%Moreover there is a plot routine for every implemented design-centering
%problem

p.plotSols( [2.1107   -1.0000    0.5615    2.3032   -0.4385],[],[])
