function [DxDyu] = DxDyAllLowLevConstrs(obj,i,x,y)
    %DxDyu=DxDyAllLowLevConstrs(i,x,y) returns the mixed seccond derivative
    %of the function evalAllLowLevConstrs with respect to x and y. 

    DxDyu=zeros(0,obj.nrOfLowLevVars(i),obj.nrOfUppLevVars);
    %Add the non linear constraints
    if obj.nrOfLowLevNonlinConstrs(i)>0
        DxDyu=obj.DxDyLowLevNonlinConstrs(i,x,y);
        
    end

    %Add the linear constraints    
    [A,b]=obj.getLinIneqsOnLowLevVars(i,x);
    [DxA,Dxb]=obj.DxLinIneqsOnLowLevVars(i,x);
    %nrLinIneqs=size(A,1);
    %DxAAsMatrix=reshape(DxA,[obj.nrOfUppLevVars*nrLinIneqs,obj.nrOfLowLevVars]);
    %vector to extract right rows
    %indexVector=(0:(obj.nrOfUppLevVars-1))*nrLinIneqs;
    %DxDyu
   
    %for j=1:nrLinIneqs 
        %DxAAsMatrix(indexVector+j,:)'
        DxDyu=[DxDyu;DxA];
    %end    
    
    
    %The constraints corresponding to the boundaries vanish.
    [lb,ub]=obj.getBoundsOnLowLevVars(i,x);
    constrlb=lb-y;
    %drop the boundaries with -inf
    constrlb=constrlb(constrlb~=-inf);    
    construb=y-ub;
    construb=construb(construb~=-inf);

    DxDyu=[DxDyu;zeros(length(constrlb)+length(construb),obj.getNrLowLevVars(i),obj.nrOfUppLevVars)];
end


