function [L] = evalLowLevLagrangeFun(obj,i,x,y,mu)
    %L=evalLowLevLangrangeFun(obj,i,x,y,mu) evaluates the largrange 
    %function of the i-th lower level problem. The function is given by:
    %
    %   L(x,y,mu)=g_i(x,y)-sum_j=1^k mu_j*u_ij(x,y)
    %
    %The first elements of mu correspond to the constraints u. The next to 
    %the linear constraintn, then the upper bounds and the last elements
    %belong to the lower bounds. The bounds which are inf or -inf are
    %dropped.

    %objective Function for the i-th LowerLevelProblem
    L=obj.evalSemiInfConstrs(i,x,y);
    %For adding the constraints find the index of the IndexSet
    indexSet=obj.getIndexSetOfSemiInfConstr(i);

    %Add all lower level constraints
    L=L-mu*obj.evalAllLowLevConstrs(indexSet,x,y)';
    %     the non linear constraints
%     if obj.nrOfLowLevNonlinConstrs(indexSet)>0
%         L=L-mu(1:obj.nrOfLowLevNonlinConstrs(indexSet))*obj.evalLowLevNonlinConstrs(indexSet,x,y)';
%         ID=ID+obj.nrOfLowLevNonlinConstrs(indexSet);
%     end
%     
%     %Add the linear constraints    
%     [A,b]=obj.getLinIneqsOnLowLevVars(indexSet,x);
%     nrLinIneqs=size(A,1);
%     L=L-mu(ID+1:ID+nrLinIneqs)*(A*y'-b);
%     ID=ID+nrLinIneqs;
%     %Add the boundaries
%     [lb,ub]=obj.getBoundsOnLowLevVars(indexSet,x);
%     constrlb=lb-y;
%     %drop the boundaries with -inf
%     constrlb=constrlb(constrlb~=-inf);
%     nrconstrlb=length(constrlb);
%     L=L-mu(ID+1:ID+nrconstrlb)*constrlb';
%     ID=ID+nrconstrlb;
%     
%     construb=y-ub;
%     construb=construb(construb~=-inf);
%     nrconstrub=length(construb);
%     L=L-mu(ID+1:ID+nrconstrub)*construb';
    
end

