function [ b ] = checkImplicitGSIPProblem( problem ,x,checkDeriv,checkSecDeriv)
%[ b ] = checkImplicitGSIPProblem( problem ,x,checkDeriv,checkSecDeriv)
%checks a part of the functions given in problem. Please use the function
%check problem instead of this function.
b=1;
nrOfSemiInfConstrs=problem.getNrSemiInfConstrs;
nrOfIndexset=problem.getNrIndexSets();

bgetNrNonlinLowLevConstrs=1;
bgetInitValsLowLevVars=1;
bgetBoundsOnLowLevVars=1;
bgetLinIneqsOnLowLevVars=1;
for j=1:nrOfIndexset
    n=problem.getNrLowLevVars(j);
    bgetNrNonlinLowLevConstrs=min(bgetNrNonlinLowLevConstrs,checkOneFunction(problem,'getNrNonlinLowLevConstrs',{[1;1]},j));

    bgetInitValsLowLevVars=min(bgetInitValsLowLevVars,checkOneFunction(problem,'getInitValsLowLevVars',{[1;n]},j,x));
    bgetBoundsOnLowLevVars=min(bgetBoundsOnLowLevVars,checkOneFunction(problem,'getBoundsOnLowLevVars',{[1,n],[1;n]},j,x));
    if bgetBoundsOnLowLevVars && checkDeriv
        bgetBoundsOnLowLevVars=min(bgetBoundsOnLowLevVars,checkOneFunctionDerivative(problem,'DxBoundsOnLowLevVars',0,'getBoundsOnLowLevVars',2,{[n],[n]},j,0,x,1));
    end
    if bgetBoundsOnLowLevVars && checkSecDeriv
        bgetBoundsOnLowLevVars=min(bgetBoundsOnLowLevVars,checkOneFunctionSecDerivative(problem,'DxDxBoundsOnLowLevVars','getBoundsOnLowLevVars',2,{[n],[n]},j,0,x,1));
    end
    
    bgetLinIneqsOnLowLevVars=min(bgetLinIneqsOnLowLevVars,checkOneFunction(problem,'getLinIneqsOnLowLevVars',{[inf,n],[inf,1]},j,x));
    if bgetLinIneqsOnLowLevVars
        [A]=problem.getLinIneqsOnLowLevVars(j,x);
        nrLinIneqs=size(A,1);
        bgetLinIneqsOnLowLevVars=checkOneFunction(problem,'getLinIneqsOnLowLevVars',{[nrLinIneqs,n],[nrLinIneqs,1]},j,x); 
    end
    
    if bgetLinIneqsOnLowLevVars && checkDeriv
         [A]=problem.getLinIneqsOnLowLevVars(j,x);
         nrLinIneqs=size(A,1);
         bgetLinIneqsOnLowLevVars=min(bgetLinIneqsOnLowLevVars,checkOneFunctionDerivative(problem,'DxLinIneqsOnLowLevVars',0,'getLinIneqsOnLowLevVars',2,{[nrLinIneqs,n],[nrLinIneqs,1]},j,0,x,1));
     end
     if bgetLinIneqsOnLowLevVars && checkSecDeriv
         [A]=problem.getLinIneqsOnLowLevVars(j,x);
         nrLinIneqs=size(A,1);
         bgetLinIneqsOnLowLevVars=min(bgetLinIneqsOnLowLevVars,checkOneFunctionSecDerivative(problem,'DxDxLinIneqsOnLowLevVars','getLinIneqsOnLowLevVars',2,{[nrLinIneqs,n],[nrLinIneqs,1]},j,0,x,1));
     end

end
if bgetNrNonlinLowLevConstrs&&bgetInitValsLowLevVars
    
    y=problem.getInitValsLowLevVars(1,x);
    bevalSemiInfConstrs=1;
    bDySemiInfConstrs=1;
    bDxSemiInfConstrs=1;
    for i=1:nrOfSemiInfConstrs
    bevalSemiInfConstrs=min(bevalSemiInfConstrs,checkOneFunction(problem,'evalSemiInfConstrs',{[1;1]},i,x,y));
    end
    if bevalSemiInfConstrs && checkDeriv
        for i=1:nrOfSemiInfConstrs
        bevalSemiInfConstrs=min(bevalSemiInfConstrs,checkOneFunctionDerivative(problem,'DxSemiInfConstrs',0,'evalSemiInfConstrs',2,{[]},i,0,x,1,y,1));
        bevalSemiInfConstrs=min(bevalSemiInfConstrs,checkOneFunctionDerivative(problem,'DySemiInfConstrs',0,'evalSemiInfConstrs',3,{[]},i,0,x,1,y,1));
        end
    end
    if bevalSemiInfConstrs && checkSecDeriv
        for i=1:nrOfSemiInfConstrs
            bevalSemiInfConstrs=min(bevalSemiInfConstrs,checkOneFunctionSecDerivative(problem,'DxDxSemiInfConstrs','evalSemiInfConstrs',2,{[]},i,0,x,1,y,1));
            bevalSemiInfConstrs=min(bevalSemiInfConstrs,checkOneFunctionSecDerivative(problem,'DyDySemiInfConstrs','evalSemiInfConstrs',3,{[]},i,0,x,1,y,1));
            bevalSemiInfConstrs=min(bevalSemiInfConstrs,checkOneFunctionMixedSecDerivative(problem,'DxDySemiInfConstrs','evalSemiInfConstrs',3,2,{[]},i,0,x,1,y,1));
        end
    end
    
    
    bevalInvTrafoFun=1;
    bevalLowLevNonlinConstrs=1;
    bDyLowLevNonlinConstrs=1;
    bevalTrafoFun=1;
    for j=1:nrOfIndexset
        n=problem.getNrLowLevVars(j);
        bevalInvTrafoFun=min(bevalInvTrafoFun,checkOneFunction(problem,'evalInvTrafoFun',{[1;inf]},j,x,y));
        if bevalInvTrafoFun
            z=problem.evalInvTrafoFun(j,x,y);
            bevalTrafoFun=min(bevalTrafoFun,checkOneFunction(problem,'evalTrafoFun',{[1;n]},j,x,z));
            if bevalTrafoFun && checkDeriv
                bevalTrafoFun=min(bevalTrafoFun,checkOneFunctionDerivative(problem,'DxTrafoFun',0,'evalTrafoFun',2,{[n]},j,0,x,1,z,1));
                bevalTrafoFun=min(bevalTrafoFun,checkOneFunctionDerivative(problem,'DzTrafoFun',0,'evalTrafoFun',3,{[n]},j,0,x,1,z,1));
            end
            if bevalTrafoFun && checkSecDeriv
                bevalTrafoFun=min(bevalTrafoFun,checkOneFunctionSecDerivative(problem,'DxDxTrafoFun','evalTrafoFun',2,{[n]},j,0,x,1,z,1));
                bevalTrafoFun=min(bevalTrafoFun,checkOneFunctionSecDerivative(problem,'DzDzTrafoFun','evalTrafoFun',3,{[n]},j,0,x,1,z,1));
                bevalTrafoFun=min(bevalTrafoFun,checkOneFunctionMixedSecDerivative(problem,'DxDzTrafoFun','evalTrafoFun',3,2,{[n]},j,0,x,1,z,1));
            end
        end

        nrOfLewLevConstrs=problem.getNrNonlinLowLevConstrs(j);
        y=problem.getInitValsLowLevVars(j,x);
        bevalLowLevNonlinConstrs=min(bevalLowLevNonlinConstrs,checkOneFunction(problem,'evalLowLevNonlinConstrs',{[1;nrOfLewLevConstrs]},j,x,y));
        if bevalLowLevNonlinConstrs && checkDeriv
            min(bevalLowLevNonlinConstrs,checkOneFunctionDerivative(problem,'DxLowLevNonlinConstrs',0,'evalLowLevNonlinConstrs',2,{[nrOfLewLevConstrs]},j,0,x,1,y,1));
            min(bevalLowLevNonlinConstrs,checkOneFunctionDerivative(problem,'DyLowLevNonlinConstrs',0,'evalLowLevNonlinConstrs',3,{[nrOfLewLevConstrs]},j,0,x,1,y,1));
        end
        if bevalLowLevNonlinConstrs && checkSecDeriv
            min(bevalLowLevNonlinConstrs,checkOneFunctionSecDerivative(problem,'DxDxLowLevNonlinConstrs','evalLowLevNonlinConstrs',2,{[nrOfLewLevConstrs]},j,0,x,1,y,1));
            min(bevalLowLevNonlinConstrs,checkOneFunctionSecDerivative(problem,'DyDyLowLevNonlinConstrs','evalLowLevNonlinConstrs',3,{[nrOfLewLevConstrs]},j,0,x,1,y,1));
            min(bevalLowLevNonlinConstrs,checkOneFunctionMixedSecDerivative(problem,'DxDyLowLevNonlinConstrs','evalLowLevNonlinConstrs',3,2,{[nrOfLewLevConstrs]},j,0,x,1,y,1));
        end
        
               
    end  
    b=min([b,bDyLowLevNonlinConstrs, bevalLowLevNonlinConstrs,bevalTrafoFun,bevalInvTrafoFun,...
             bDxSemiInfConstrs,bDySemiInfConstrs,bevalSemiInfConstrs]);
end

    

        
b=min([b,bgetNrNonlinLowLevConstrs,bgetInitValsLowLevVars,bgetBoundsOnLowLevVars,bgetLinIneqsOnLowLevVars]);
    
   
end

